
## Recap
- Learned basic expressions
- Learned how to count (more or less)
- Learned how to ask and provide personal information
- Understood basic conversation (70%)


## Vocabulary additions
### Phrases
- Ik ben -> I am
- Ik studeen -> I study
- Ik woon in -> I reside in (country)
- Mijn naam is -> My name is
- Ik doe -> I am doing
- Hoe zeg je ... ? -> How do you say?
- Hoe spreek je ... **uit**? -> How do you pronounce ...?
- Herhaal = Repeat
- Leer = Learn
- Maak = Make
- Kijk = Watch

### Verbs
- luisteren -> to listen
- nazeggen -> to repeat
- lezen -> tor read
- oefenen -> to practice
- hebben -> to have

### Nouns
- bladzijde -> page
- klemtoon -> emphasis

### Numbers

| English       | Dutch                           |
| ------------- | ------------------------------- |
| zero          | nul (nuhl)                      |
| one           | een (e-yn)                      |
| two           | twee (tvey)                     |
| three         | drie (dree)                     |
| four          | vier (fvier)                    |
| five          | vijf (faeif)                    |
| six           | zes                             |
| seven         | zeven (zayfe)                   |
| eight         | acht                            |
| nine          | negen (neiche)                  |
| ten           | tien (teen)                     |
| *eleven*      | *elf*                           |
| *twelve*      | *twaalf* (tvaalv)               |
| thir**teen**  | der**tien** (dur-teen)          |
| four**teen**  | veer**tien** (vierteen)         |
| fif**teen**   | vijf**tien** (faif-teen)        |
| six**teen**   | zes**tien** (zes-teen)          |
| seven**teen** | zeven**tien** (zayfenteen)      |
| eigh**teen**  | acht**tien** (acht-teen)        |
| nine**teen**  | negen**tien** (neichenteen)     |
| twenty        | twintig (tvintugh)              |
| twenty-one    | eenentwintig (e-yn en tvintugh) |
| thirty        | dertig (dur-tugh)               |
| fourty        | veertig (fvier-tugh)            |
| fifty         | vijftig (faeif-tugh)            |
| sixty         | zestig (zes-tugh)               |
| seventy       | zeventig (zayven-tugh)          |
| eighty        | **tachtig** (tagh-tugh)         |
| ninety        | negentig (neighen-tuch)         |
| hundred       | honderd                         |
- 10-20 has the same logic as English
- When adding a digit to a 2-digit number (i.e. 21), you say the second digit first (i.e. one) and then the first (amount of 10s, i.e. 20).
	- In English, 21 would be one and twenty if the same logic applied
	- 21 - een en twintig
- 80 (**t**achtig) has an extra **t** in the beginning for some reason
## Personal pronouns

| Face         | Pronoun           |
| ------------ | ----------------- |
| 1            | ik                |
| 2 (informal) | jij/je            |
| 2 (formal)   | u                 |
| 3            | hij, zij / ze,het |
| 1            | wij/we            |
| 2            | jullie            |
| 3            | zij/ze            |

## Grammatical rules
### Formal "you"
- u -> formal
- jij/je -> informal

### Difference between *jij* & *je*
> Jij is used when an emphasis is being put on the word. You cant say "Ik ben Boyan, en je?", you should say "Ik ben Boyan, en jij?"

*jij* - is used for PARTICULAR emphasis on the person. you can always use the stressed form.

Same goes for *wij*(we) and *zij*(them).
These are called [[Linguistic Terms#Emphatic forms |Emphatic forms]].


### Conjugation rules
Whenever *jij/je* appears after the verb, the t gets dropped (if the verb doesn't usually end in a t).
### Conjugation of regular verbs
luisteren - listen
komen - come

|                    | luisteren | komen |
| ------------------ | --------- | ----- |
| ik                 | luister   | kom   |
| jij/je             | luistert  | komt  |
| u                  | luistert  | komt  |
| hij, zij / ze, het | luistert  | komt  |
| wij / we           | luisteren | komen |
| jullie             | luisteren | komen |
| zij / ze           | luisteren | komen |

### Conjugation of irregular verbs 
heb - have
zijn - are

|                    | hebben     | zijn |
| ------------------ | ---------- | ---- |
| ik                 | heb        | ben  |
| jij/je             | hebt       | bent |
| u                  | hebt/heeft | bent |
| hij, zij / ze, het | heeft      | is   |
| wij/we             | hebben     | zijn |
| jullie             | hebben     | zijn |
| zij/ze             | hebben     | zijn |

## Homework
### Words
- jullie - You/Yours (plural)
- docent - teacher

