# Approach

## Routine aspirations

Inspired by [this post](https://old.reddit.com/r/PhysicsStudents/comments/1e289f4/what_should_be_my_daily_routine_to_be_a_physicist/ "https://old.reddit.com/r/PhysicsStudents/comments/1e289f4/what_should_be_my_daily_routine_to_be_a_physicist/"). Remember to take this step by step, keep going at it from different angles and you **will** succeed. Do **not** try to do this all at once, as you'll burn yourself out real fuckin fast.

1. Solid sleep schedule
    - i.e. 8:00 - 11:00 with an hour or 2 wiggle room
    - This implies **NO** voluntary nightly activities (playing games and minimize staying outside)
2. Regular workout routine
    - Climbing ~2-3 hours, 1-2 days a week
    - Gym (weights) ~1h, 1-2 days a week
3.  **Eliminate** bad habits like doom-scrolling, brain-rotting, etc. Take your time and do this in a calculated manner. Seek to replace counter-productivity with pseudo-, then finally, actual productivity
4. Read scientific papers on the surface, from abstract straight to conclusion (~2h/week), read fully if interesting, of course
5. **Actively enjoy hobbies**. Needless to say, time for hobbies is necessary. Instead of mindlessly watching youtube videos/playing games, try to **pay attention to each hobby and treat it as such**.
6. Stick to **one** set of tutorials and labs and **go to each one**, no matter how easy they seem
7. Read at least 30 pages of your favorite book each night
8. Avoid ordering food as much as possible, try to aim for a protein-rich, balanced (as much as possible) diet. Keep taking your supplements each day.
9. Make sure to make time for socializing, whether that'd be with Marty or with friends
    - When it comes to Marty, be clear and stern about your plans (this requires you to think them through)

![[Proposed Routine Plan.canvas|Proposed Routine Plan]]

## Proven studying tactics

For me of course.

- Print out mindmaps and other easily digestible forms of information, relevant to current material and stick them to the wall
- "Create" videos/explain the content to somebody else
    - When reading through exercises and/or theory, draw over the pdf with notes while talking
- Do not procrastinate solving exercises, no matter how tedious they are

## Ideas

- Do not be afraid of deeply technical conversations. At the absolute _very_ least, if you have absolutely nothing to offer to the conversation, your jargon and perception gets an upgrade.
- Clean ur desk once in a while
- Schedule more social stuff like gatherings and dates with Marty

## Important concepts

> There are two things you can consider: **short time slot** and **long time** slots. Your short time slots can be spent on pleasure reading (articles, coding practice, reddit, google searches), and your long time slots should be devoted to HW and research. Things like preparing for your classes/appointments can be done in either depending on priority. Obviously, the two types of time-blocks will not always be disjointed in terms of the type of work you do with each one.

> "You need to study every moment of every day, sacrifice your life for ~~physics~~ CS, okay, bye".  
> Politely reject that attitude. You want to study 6 days a week. Seven just isn't sustainable. Each day you study, you want to study ~~at least six hours~~ . This time needs to be productive. Focus on solving problems. When you read theory and math, don't just scan the words, pull out paper and writing implement and follow along.

> Once you hit this goal, if you don't feel like studying anymore, DON'T. Go relax. Explore your interests. Your central nervous system did a lot of work. It needs to recover.

> Prioritize your sleep. Staying up all night is a losing wager 9 / 10 times. You're not gaining any real time, you're just borrowing it from your future self.

# Course timeline

## Interesting Courses

| Name (link)               | Code     | Time |
| ------------------------- | -------- | ---- |
| Philosophy of Mathematics | FI213BK  | 1a   |
| Spectroscopy              | WBCH044  | 2b   |
| Mechanics and Relativity  | WBMA060  | 2a   |
| Theory of Science         | PSBE2-05 | 2b   |
| Cognitive Psychology      | PSBE2-23 | 2b   |
| Digital Signal Processing | WBPH067  | 2b   |

## Block 1

- LinAlg - WBMA020
- Advanced Algorithms - WBCS052
- Advanced Programming - WBCS053
- Calculus 2 - WBCS054
- Algorithmic Programming Contests - WBCS045-05
## Block 2

- FuncProg - WBCS002
- WebEng - WBCS008
- DS - WBCS011
- Stats - WBCS049
- Algorithmic Programming Contests - WBCS045-05

## Block 3

- ==Software Engineering - WBCS017==
- Operating systems - WBCS023
- Intro to ML - WBCS032
- Software and Systems Security - ==WMCS034==
- Algorithmic Programming Contests - WBCS045-05

## Block 4

- ==Software Engineering - WBCS017==
- L&M - WBCS027
- Intro to CG - WBCS056
- Algorithmic Programming Contests - WBCS045-05
- Empty!!!