
## Microcontroller: STM32G071RB
![](Pasted%20image%2020241206133007.png)
[Source](https://www.st.com/resource/en/datasheet/stm32g071rb.pdf)

-  32-bit ARM Cortex-M0+
- 64 MHz
- 128 KB of Flash memory
-  36KB of SRAM
- I2C, SPI, and UART,
- Hella low power
- $3.64
	- 10.51 for a devboard (it has a built-in st-link)

##  Telemetry: HopeRF RFM98W LoRa Module
![](Pasted%20image%2020241206134156.png)

- Low-power
- 0.3 kbps to 37.5 kbps and
- -148 dBm
- 10$

## Custom Flexible PCB
Why? Mostly because we can, but it also minimizes the weight and makes the whole thing more rigid and not susceptible to fall damage.


## Sensors



- BME280 - 5.50
	- Pressure, Humidity, Temperature, Altitude
	- ![](Pasted%20image%2020241206134207.png)
- Accelerometer and Gyroscope: MPU6050 6-axis IMU - €3,75
- ![](Pasted%20image%2020241206134213.png)



### Estimated** Costs

| Description                           | Quantity | Unit Price (EUR) | Source                                                                                                                                |
| ------------------------------------- | -------- | ---------------- | ------------------------------------------------------------------------------------------------------------------------------------- |
| STM32G071RB                           | 1        | €3.64            | [STMicroelectronics](https://www.st.com/resource/en/datasheet/stm32g071rb.pdf)                                                        |
| 433 MHz Wireless Transceiver (RFM98W) | 1        | €10              | [TinyTronics](https://www.tinytronics.nl/en/communication-and-signals/wireless/lora/modules/hoperf-rfm98w-lora-module-433mhz)         |
| Custom Flexible PCB (5 pcs)           | 1 set    | €30 (?)          | [JLCPCB](https://jlcpcb.com/resources/flexible-pcb)                                                                                   |
| BME280 Sensor                         | 1        | €5.50            | [TinyTronics](https://www.tinytronics.nl/en/sensors/air/pressure/bme280-digital-barometer-pressure-and-humidity-sensor-module)        |
| 6-axis IMU (MPU6050)                  | 1        | €8.50            | [TinyTronics](https://www.tinytronics.nl/en/sensors/acceleration-rotation/mpu-6050-accelerometer-and-gyroscope-3-axis-module-3.3v-5v) |
| Standard 9V Alkaline Battery          | 1        | €2.00            | [Amazon](https://www.amazon.com/)                                                                                                     |
|                                       |          | **€57.64**       |                                                                                                                                       |
