
## Hard disks (HDDs)
Spin platters of magnetically-coated material under moving RW heads
- Rotate at 60 to 250 times/s
- Transfer rate is rate at which data flows between drive and pc
- Positioning time (Random access time) to move disk arm to desired cylinder (seek time) and time for desired sector to rotate under the disk head (rotational latency)

![](Pasted%20image%2020250505201859.png)


### Controller
Receives data/ command from the OS, controls I/O operation and sends back results to OS
![](Pasted%20image%2020250505201950.png)


### I/O steps
- Move head to track -> Seek Time (S)
- Find sector -> Rotational Latency Time (r)
- Transfer data to/from controller -> Block Transfer Time (btt)
- Error checking and report to OS


### Disk Formatting
Each platter must receive a low-level format done by software, i.e. marking the cylinders and tracks, each containing a few sectors, with short gaps in between

Each sector includes:
- Preamble: starts with start of the sector bit pattern, the cylinder and sector numbers
- Data: size of the data portion is determined by the formatting program -> 512 bytes usually
- ECC: error correction, typically 16 bytes


Numbering the sectors
- Position of sector 0 on each track is offset from the previous track when the low-level format is laid down (cylinder skew)


![](Pasted%20image%2020250505202532.png)

![](Pasted%20image%2020250505203114.png)